{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  TMatrix = array[0..6] of array[0..4] of char;

const
  LetterA: TMatrix = (
    '..#..',
    '.#.#.',
    '#...#',
    '#...#',
    '#####',
    '#...#',
    '#...#'
  );

  MaxA = 100;
  MaxN = 10*1000;

var
  a, b: array of array of char;
  i, j, w, h, n, x, y: integer;
  fin, fout, fans: text;

procedure Ex(const s: string; ec: integer);
begin
  write(s);
  try
    close(fin); close(fout); close(fans);
  except
  end;
  halt(ec);
end;

function GetNextInt: integer;
begin
  if SeekEOF(fout) then Ex('Too few numbes', 2);
  try
    read(fout, Result);
  except on e: Exception do
    Ex('PE: ' + e.Message, 2);
  end;  
end;

procedure DrawLetterA(x, y: integer);
var i, j: integer;
begin
  for i := y to y+6 do
    for j := x to x+4 do
      begin
        if (i < 0) or (i > h) or (j < 0) or (j > w) then
          Ex(format('Overrunning on (x: %d; y: %d) letter', [x, y]), 1);
        if (a[i, j] <> '#') then a[i, j] := LetterA[i-y, j-x];
      end;
end;

begin
  try
    assign(fin,paramstr(1)); reset(fin);
  except on e: Exception do
    Ex('Error opening input: ' + e.Message, 3);
  end;
  try
    assign(fans,paramstr(3)); reset(fans);
  except on e: Exception do
    Ex('Error opening answer: ' + e.Message, 3);
  end;
  try
    assign(fout,paramstr(2)); reset(fout);
  except on e: Exception do
    Ex('Can''t open output: ' + e.Message, 2);
  end;
  try
    readln(fin, w, h);
    SetLength(a, h, w);
    SetLength(b, h, w);
    dec(w); dec(h);
    for i := 0 to h do
      for j := 0 to w do
        a[i, j] := '.';
    for i := 0 to h do
      begin
        for j := 0 to w do
          begin
            read(fin, b[i, j])
          end;
        readln(fin);
      end;
  except on e: Exception do
    Ex('Invalid input: ' + e.Message, 3);
  end;
  n := GetNextInt;
  if (n < 0) or (n > MaxN) then Ex('Invalid letters number: '+IntToStr(n), 2);
  for i := 1 to n do
    begin
      x := GetNextInt; y := GetNextInt;
      DrawLetterA(x, y);
    end;
  if not SeekEof(fout) then
    Ex('Too many numbers', 2);
  for i := 0 to h do
    for j := 0 to w do
      if a[i, j] <> b[i, j] then
        Ex(format('''%s'' instead of ''%s'' in (x: %d; y: %d) position', [a[i, j], b[i, j], j, i]), 1);
  Ex('', 0);
end.