{$APPTYPE CONSOLE}

uses
  SysUtils;

type
  TMatrix = array[0..6] of array[0..4] of char;
  TPoint = record x, y: integer; end;

const
  LetterA: TMatrix = (
    '..#..',
    '.#.#.',
    '#...#',
    '#...#',
    '#####',
    '#...#',
    '#...#'
  );

  MaxA = 100;
  MaxN = 10*1000;

var
  a: array[0..MaxA, 0..MaxA] of char;
  vis: array[0..MaxA, 0..MaxA] of boolean;
  ans: array[1..MaxN] of TPoint;
  HavePoint: boolean;
  i, j, w, h, AnsCount, hh, ww: integer;
  fi, fo: text;

function can(x, y: integer): boolean;
var i, j: integer;
begin
  Result := false;
  for i := y to y+6 do
    for j := x to x+4 do
      begin
        if (i < 0) or (j < 0) or (i > h) or (j > w) then continue;
        if (LetterA[i-y, j-x] = '#') and (a[i, j] <> '#') then exit;
      end;
  for i := y to y+6 do
    for j := x to x+4 do
      begin
        if (i < 0) or (j < 0) or (i > h) or (j > w) then continue;
        if LetterA[i-y, j-x] = '#' then
          begin
            Result := true;
            vis[i, j] := true;
          end;
      end;
end;

procedure AddToAns(x, y: integer);
begin
  inc(AnsCount);
  ans[AnsCount].x := x;
  ans[AnsCount].y := y;
end;

begin
  HavePoint := false;
  FillChar(vis, SizeOf(vis), false);
  AssignFile(fi, 'input.txt');
  AssignFile(fo, 'output.txt');
  reset(fi);
  rewrite(fo);
  readln(fi, w, h);
  assert((w > 0) and (h > 0) and (w <= MaxA) and (h <= MaxA), 'Invalid field width');
  dec(w); dec(h);
  for i := 0 to h do    
    begin
      for j := 0 to w do
        begin
          read(fi, a[i, j]);
          HavePoint := HavePoint or (a[i, j] = '#');
          assert(a[i, j] in ['.', '#'],
            format('Invalid character ''%s''(code: %d) in (x: %d; y: %d) position',
              [a[i, j], ord(a[i, j]), j, i]));
        end;    
      readln(fi);
    end;
  ww := w - 4; hh := h - 6;
  if HavePoint then assert((ww >= 0) and (hh >= 0), 'Invalid field width');
  for i := 0 to hh do
    for j := 0 to ww do
      if can(j, i) then AddToAns(j, i);
  for i := 0 to h do
    for j := 0 to w do
      assert((a[i, j] <> '#') or vis[i, j], 'Incorrect test');
  writeln(fo, AnsCount);
  for i := 1 to AnsCount do
    begin
      writeln(fo, ans[i].x, ' ', ans[i].y);
    end;
  CloseFile(fi);
  CloseFile(fo);
end.